;The G.E.C.K. PowerUp for New Vegas - Part of the library
;Hack to make GECK show PortalMarkers and RoomMarkers
;File version 0.1.2
;Written by Fedor Uvarov, 2010
;Patched to support G.E.C.K 1.4 by H. LE PORS ( 7 July 2011)

PATCH_MARKERHACK_ROOMMARKER_MAGIC_OFFSET = 00EDDA48h	;       00EDD9C8h    ;      00EDC628h
PATCH_MARKERHACK_PORTALMARKER_MAGIC_OFFSET = 00EDDA4Ch	;       00EDD9CCh  ;      00EDC62Ch
; reference to 00EDC630 that become 00EDD9D0 then 00EDDA50
PATCH_MARKERHACK_LOADFINISHED_OFFSET = 004D2E1Bh	;       004D2C2Bh ;       004D1F1Bh
;004D1F1B  3BC3  CMP EAX,EBX
;004D1F1D  0F85 8C000000  JNE 004D1FAF  ;       becomes JNE 004D2CBF    then    JNE 004D2EAF
PATCH_MARKERHACK_LOADFINISHED_LENGTH = 8
PATCH_MARKERHACK_LOADFINISHED_JNE_RETURN = 004D2EAFh	;       004D2CBFh     ;       004D1FAFh


macro MARKERHACK_DATA {
EnableMarkerHack db "PowerUp Marker hack", 0
EndOf_EnableMarkerHack:
bMarkersHacked db FALSE
RoomMarkerValue dd 0
PortalMarkerValue dd 0
}

macro MARKERHACK_PATCHES {
	stdcall MakeMemWriteable, PATCH_MARKERHACK_LOADFINISHED_OFFSET, PATCH_MARKERHACK_LOADFINISHED_LENGTH
	mov [PATCH_MARKERHACK_LOADFINISHED_OFFSET], BYTE 0E8h
	mov eax, Callback_FinishedLoadingMarkers
	sub eax, PATCH_MARKERHACK_LOADFINISHED_OFFSET+5
	mov [PATCH_MARKERHACK_LOADFINISHED_OFFSET+1], eax
	mov [PATCH_MARKERHACK_LOADFINISHED_OFFSET+5], WORD 9090h
	mov [PATCH_MARKERHACK_LOADFINISHED_OFFSET+7], BYTE 90h
	call RestoreMemProtection
}

macro MARKERHACK_CALLBACKS {
Callback_FinishedLoadingMarkers:
	.if [bMarkersHacked]
		HACK_MARKERS
	.endif
	cmp eax, ebx
	jne .return_ne
	
	retn
	
	.return_ne:
	mov [esp], DWORD PATCH_MARKERHACK_LOADFINISHED_JNE_RETURN
	retn
}

;Stack is supposed to contain MENUITEMINFO
macro MARKERHACK_MAINMENU {
	mov [esp+MII_fMask], DWORD MIIM_STRING + MIIM_ID + MIIM_STATE
	mov [esp+MII_wID], DWORD MENU_MARKERHACK
	mov [esp+MII_fState], DWORD MFS_UNCHECKED
	mov [esp+MII_dwTypeData], DWORD EnableMarkerHack
	mov [esp+MII_cch], DWORD EndOf_EnableMarkerHack - EnableMarkerHack
	invoke InsertMenuItem, [hMainMenu], MENU_OLD_LIGHTMARKERS, FALSE, esp
	mov [esp+MII_fState], DWORD 0
}

macro MARKERHACK_MENUCOMMAND_MARKERHACK {
	MakeMENUITEMINFO
	mov [esp+MII_fMask], DWORD MIIM_STATE
	
	.if [bMarkersHacked]
		mov eax, [RoomMarkerValue]
		mov [PATCH_MARKERHACK_ROOMMARKER_MAGIC_OFFSET], eax
		mov eax, [PortalMarkerValue]
		mov [PATCH_MARKERHACK_PORTALMARKER_MAGIC_OFFSET], eax
		mov [bMarkersHacked], FALSE
		mov [esp+MII_fState], DWORD MFS_UNCHECKED
	.else
		HACK_MARKERS
		mov [bMarkersHacked], TRUE
		mov [esp+MII_fState], DWORD MFS_CHECKED
	.endif
	
	invoke SetMenuItemInfo, [hMainMenu], MENU_MARKERHACK, FALSE, esp
	add esp, sizeof.MENUITEMINFO + 4	;+4 to compensate for a bug in FASM headers. Will fix it normally in 0.2.0
}

macro HACK_MARKERS {
	mov eax, [PATCH_MARKERHACK_ROOMMARKER_MAGIC_OFFSET]
	mov [RoomMarkerValue], eax
	mov [PATCH_MARKERHACK_ROOMMARKER_MAGIC_OFFSET], DWORD 0
	mov eax, [PATCH_MARKERHACK_PORTALMARKER_MAGIC_OFFSET]
	mov [PortalMarkerValue], eax
	mov [PATCH_MARKERHACK_PORTALMARKER_MAGIC_OFFSET], DWORD 0
}