;The G.E.C.K. PowerUp for New Vegas - Part of the library
;Restoration of report, warning and info messages
;File version 0.5
;Written by Fedor Uvarov, 2010

PATCH_REPORTPROCS_LENGTH = 4
CONSTANT_REPORT_WARNING = 1
CONSTANT_REPORT_REPORT = 2
CONSTANT_REPORT_MINERROR = 4

macro REPORTPROCS_DATA {
ReportCaption db "Warning - PowerUp - REPORTS", 0
ReportEnding db 0Dh, 0Ah, 0Dh, 0Ah, 'This is a REPORT. "Cancel" will disable all REPORTS.', 0
EndOf_ReportEnding:
WarningEnding db 0Dh, 0Ah, 0Dh, 0Ah, 'This is a WARNING. "Cancel" will disable all WARNINGS.', 0
EndOf_WarningEnding:
ErrorEnding db 0Dh, 0Ah, 0Dh, 0Ah, 'This is an ERROR. "Cancel" will do nothing, but PowerUp will tell it to GECK, maybe something will happen.', 0
EndOf_ErrorEnding:
bShowReports db 1
bShowWarnings db 1
bShowErrors db 1
ErrorShowingMessage db "PowerUp internal error: cannot show a message", 0
OriginString db "%s", 0Dh, 0Ah, 0Dh, 0Ah, "Origin: %08X", 0Dh, 0Ah, '"Yes to all" will disable all warnings of this origin.', 0
}

macro REPORTPROCS_ApplyPatch TargetOffset {
;All patches are call <something> -> call ShowReport
;Offsets must be increased by one
push PATCH_REPORTPROCS_LENGTH
push TargetOffset+1
call MakeMemWriteable
mov eax, Callback_ShowReport
sub eax, TargetOffset+5
mov [TargetOffset+1], eax
call RestoreMemProtection
}

macro REPORTPROCS_PATCHES {
	include 'library\report-procs-patches.asm'
}

macro REPORTPROCS_CALLBACKS {
proc DoShowReport Origin, MsgAddr, MsgSize
	stdcall sprintf_instack_align, esp, OriginString, [MsgAddr], [Origin]
	push ecx
	ShowWarning ReportCaption, edx, MB_YESNOCANCEL + MB_ICONWARNING
	pop ecx
	add esp, ecx
	ret
endp

Callback_ShowReport:
	;Args: <format line> <format args>
	;Stack is cleared by the caller
	pushad
	invoke EnterCriticalSection, ReportCriticalSection
	lea eax, [esp+36]
	stdcall printf_call, eax, DoShowReport, [esp+32]
	.if eax = IDCANCEL	;If the user pressed "Cancel", disable args from the same origin
		mov eax, [esp+32]
		sub eax, 5
		stdcall PatchWithNops, eax, 5
	.endif
	invoke LeaveCriticalSection, ReportCriticalSection
	popad
	retn
}