;The G.E.C.K. PowerUp for New Vegas - Part of the library
;Patches for windows creation and control
;File version 0.6.2
;Written by Fedor Uvarov, 2010
;Patched to support G.E.C.K 1.4 by H. LE PORS ( 7 July 2011)

;This module hijacks calls to window and dialog creation procedures.
;Its main task is to modify menus and replace window procedures.
;Here is where all PATCH_MENUs and PATCH_MENUCOMMAND_WHATEVERs go.

;CONSTANTS
;New menu items
;They are all here for all modules to avoid confusion
MENU_BASE = 50000d	;The first ID to assign
MENU_OBJECTLISTCOLS_SEP = MENU_BASE
MENU_SPELLCHECK = MENU_BASE + 1
MENU_SCRIPTEDITOR_SAVENOCOMPILE = MENU_BASE + 2
MENU_MARKERHACK = MENU_BASE + 3
	
MENU_OLD_VERSIONCONTROL = 239d	;The version control button which is after "Save" but hidden
MENU_OLD_OBJECTLISTCOLS = 40700d
MENU_OLD_LIGHTMARKERS = 40632d
	
MENU_SCRIPTEDITOR_OLD_SAVE = 40154d
MENU_SCRIPTEDITOR_OLD_DELETE = 40158d

MENU_FORMLISTEDITOR_OLD_EDIT = 250d

;RegisterClass hijacking (to modify the main window)
PATCH_REGISTERCLASS_OFFSET = 0044614Bh	;    0044660Bh  ;    004461BBh
PATCH_REGISTERCLASS_LENGTH = 4

;CreateWindowEx hijacking (to modify the main window)
PATCH_CREATEWINDOWEX_OFFSET = 00446370h  ;    00446830h  ;    004463E0h this is a guess based on proximity to the original offset and identical dwStyle
PATCH_CREATEWINDOWEX_LENGTH = 4

;Script editor window
PATCH_SCRIPTEDITOR_DIALOGCREATION_OFFSET = 0043789Fh	;       00437F0Fh    ;        0043798Fh
PATCH_SCRIPTEDITOR_DIALOGCREATION_OFFSET2 = 005C50DDh	;       005C4F4Dh    ;        005C4B0Dh   ;When editing existing script
PATCH_SCRIPTEDITOR_DIALOGCREATION_LENGTH = 4

;Form list editor window
FORMLISTEDITOR_DIALOG_ID = 3274d
PATCH_FORMLISTEDITOR_DIALOGCREATION_OFFSET = 0043790Bh	;       00437F7Bh  ;       004379FBh
PATCH_FORMLISTEDITOR_DIALOGCREATION_OFFSET2 = 004376A8h ;       00437D18h  ;       00437798h
PATCH_FORMLISTEDITOR_DIALOGCREATION_LENGTH = 4


macro WINDOWS_DATA {
	;Main window
	MainWindowClass db "Garden of Eden Creation Kit", 0
	MainWndNormalProc dd ?
	MainMenuName db "MAINMENU", 0
	AddrOf_Callback_CreateWindowEx dd ?
	AddrOf_Callback_RegisterClass dd ?	
	
	;Script editor
	AddrOf_Callback_CreateSEDialog dd ?
	AddrOf_NormalSEDlgProc dd ?
	
	;Form List editor
	AddrOf_Callback_CreateFLSTDialog dd ?
	AddrOf_NormalFLSTDlgProc dd ?
}

macro WINDOWS_PATCHES {
	;RegisterClass hijacking
	stdcall MakeMemWriteable, PATCH_REGISTERCLASS_OFFSET, PATCH_REGISTERCLASS_LENGTH
	mov [AddrOf_Callback_RegisterClass], DWORD Callback_RegisterClass
	;mov esi, dword ptr ds:[<RegisterClassA>] -> mov esi, dword ptr ds:[AddrOf_Callback_RegisterClass]
	mov [PATCH_REGISTERCLASS_OFFSET], DWORD AddrOf_Callback_RegisterClass
	call RestoreMemProtection

	;CreateWindowEx hijacking
	stdcall MakeMemWriteable, PATCH_CREATEWINDOWEX_OFFSET, PATCH_CREATEWINDOWEX_LENGTH
	mov [AddrOf_Callback_CreateWindowEx], Callback_CreateWindowEx
	mov [PATCH_CREATEWINDOWEX_OFFSET], DWORD AddrOf_Callback_CreateWindowEx
	call RestoreMemProtection

	;Hijacking the Script Editor dialog creation
	stdcall MakeMemWriteable, PATCH_SCRIPTEDITOR_DIALOGCREATION_OFFSET, PATCH_SCRIPTEDITOR_DIALOGCREATION_LENGTH
	mov [AddrOf_Callback_CreateSEDialog], Callback_CreateSEDialog
	;call dword ptr ds:[<CreateDialogParamA>] -> call dword ptr ds:[AddrOf_Callback_CreateSEDialog]
	mov [PATCH_SCRIPTEDITOR_DIALOGCREATION_OFFSET], DWORD AddrOf_Callback_CreateSEDialog
	call RestoreMemProtection

	;Hijacking the Script Editor dialog creation (in the second place)
	stdcall MakeMemWriteable, PATCH_SCRIPTEDITOR_DIALOGCREATION_OFFSET2, PATCH_SCRIPTEDITOR_DIALOGCREATION_LENGTH
	;call dword ptr ds:[<CreateDialogParamA>] -> call dword ptr ds:[AddrOf_Callback_CreateSEDialog]
	mov [PATCH_SCRIPTEDITOR_DIALOGCREATION_OFFSET2], DWORD AddrOf_Callback_CreateSEDialog
	call RestoreMemProtection

	;Hijacking the Form List Editor dialog creation
	stdcall MakeMemWriteable, PATCH_FORMLISTEDITOR_DIALOGCREATION_OFFSET, PATCH_FORMLISTEDITOR_DIALOGCREATION_LENGTH
	mov [AddrOf_Callback_CreateFLSTDialog], Callback_CreateFLSTDialog
	;call dword ptr ds:[<CreateDialogParamA>] -> call dword ptr ds:[AddrOf_Callback_CreateFLSTDialog]
	mov [PATCH_FORMLISTEDITOR_DIALOGCREATION_OFFSET], DWORD AddrOf_Callback_CreateFLSTDialog
	call RestoreMemProtection

	;Second place
	stdcall MakeMemWriteable, PATCH_FORMLISTEDITOR_DIALOGCREATION_OFFSET2, PATCH_FORMLISTEDITOR_DIALOGCREATION_LENGTH
	;call dword ptr ds:[<CreateDialogParamA>] -> call dword ptr ds:[AddrOf_Callback_CreateFLSTDialog]
	mov [PATCH_FORMLISTEDITOR_DIALOGCREATION_OFFSET2], DWORD AddrOf_Callback_CreateFLSTDialog
	call RestoreMemProtection
}

;Auxiliary macro that creates MENUITEMINFO on the stack
;ESP will be set to the start of the structure
macro MakeMENUITEMINFO {
	push DWORD 0	;hbmpItem
	push DWORD 0	;cch
	push DWORD 0	;dwTypeData
	push DWORD 0	;dwItemData
	push DWORD 0	;hbmpUnchecked
	push DWORD 0	;hbmpChecked
	push DWORD 0	;hSubMenu
	push DWORD 0	;wID
	push DWORD 0	;fState
	push DWORD 0	;fType
	push DWORD 0	;fMask
	push sizeof.MENUITEMINFO	;cbSize
}

;MENUITEMINFO offsets
MII_cbSize = 0
MII_fMask = 4
MII_fType = 8
MII_fState = 12
MII_wID = 16
MII_hSubMenu = 20
MII_hbmpChecked = 24
MII_hbmpUnchecked = 28
MII_dwItemData = 32
MII_dwTypeData = 36
MII_cch = 40
MII_hbmpItem = 44

macro WINDOWS_CALLBACKS {
	Callback_RegisterClass:
		mov eax, [esp+4]
		push eax
		invoke lstrcmp, MainWindowClass, [eax+36]
		test eax, eax
		pop eax
		jnz .run_normally
	
		mov eax, [esp+4]
		push DWORD [eax+4]	;WindowProc
		pop [MainWndNormalProc]
		mov [eax+4], DWORD Callback_MainWindowProc
	
		.run_normally:
		push DWORD [RegisterClass]
		ret
	
	Callback_MainWindowProc:
		mov eax, esp
		add eax, 8
		cmp [eax], DWORD WM_COMMAND
		jne Callback_MainWindowProc.run_normally
		
		add eax, 4
		.if [eax] = DWORD MENU_SPELLCHECK
			SPELLCHECK_MENUCOMMAND_SPELLCHECK
		.elseif [eax] = DWORD MENU_MARKERHACK
			MARKERHACK_MENUCOMMAND_MARKERHACK
		.endif
		invoke DrawMenuBar, [esp+4]
	
		Callback_MainWindowProc.run_normally:
		push [MainWndNormalProc]
		ret

	Callback_CreateWindowEx:
		push DWORD [esp + 8]
		push MainWindowClass
		invoke lstrcmp
		test eax, eax
		jnz Callback_CreateWindowEx.run_normally

		CopyStackDWORDs 12	;Copying parameters for CreateWindowEx
		invoke CreateWindowEx
		test eax, eax
		jnz Callback_CreateWindowEx.noerror_create_window
		ret
	
		Callback_CreateWindowEx.noerror_create_window:
		push eax
		invoke GetMenu, eax
		mov [hMainMenu], eax
	
		;Now adding the spellchecker enabler/disabler
		MakeMENUITEMINFO
		SPELLCHECK_MAINMENU
		MARKERHACK_MAINMENU
		add esp, sizeof.MENUITEMINFO + 4	;TODO: insert fixed MENUITEMINFO instead of the one in FASM headers
		mov eax, [esp]	;Window handle
		invoke SetMenu, eax, [hMainMenu]
		mov eax, [esp]
		invoke DrawMenuBar, eax
		pop eax
		retn 48
	
		Callback_CreateWindowEx.run_normally:
		push [CreateWindowEx]
		ret
	
	Callback_CreateSEDialog:
		;Copy parameters
		mov eax, esp
		push DWORD [eax+20]
		push DWORD [eax+16]
		pop [AddrOf_NormalSEDlgProc]	;A global can be used since there is only one dialog proc
		push DWORD Callback_SEDialogProc
		push DWORD [eax+12]
		push DWORD [eax+8]
		push DWORD [eax+4]
		invoke CreateDialogParam
		test eax, eax
		jz Callback_CreateSEDialog.exitproc
	
		;Modifying the menu
		push eax	;Window handle
		invoke GetMenu, eax
		MakeMENUITEMINFO
		SCRIPTS_COMPILATION_BYPASS_SCRIPTEDITORMENU
		add esp, sizeof.MENUITEMINFO + 4
		pop eax
	
		Callback_CreateSEDialog.exitproc:
		retn 20
	
	Callback_SEDialogProc:
		cmp [esp+8], DWORD WM_COMMAND
		jne Callback_SEDialogProc.run_normally
	
		cmp [esp+12], DWORD MENU_SCRIPTEDITOR_SAVENOCOMPILE
		jne Callback_SEDialogProc.run_normally
	
		SCRIPTS_COMPILATION_BYPASS_MENUCOMMAND_SAVENOCOMPILE
		invoke DrawMenuBar, [esp+4]
	
		Callback_SEDialogProc.run_normally:
		push [AddrOf_NormalSEDlgProc]
		ret
		
	Callback_CreateFLSTDialog:
		;We replace CreateDialogParamA
		cmp [esp+8], DWORD FORMLISTEDITOR_DIALOG_ID
		jne .run_normally
		
		;Replacing dialog proc
		mov eax, [esp+16]
		mov [AddrOf_NormalFLSTDlgProc], eax
		mov [esp+16], DWORD Callback_FLSTDlgProc
		
		.run_normally:
		push [CreateDialogParam]
		ret
		
	Callback_FLSTDlgProc:
		;We are a legitimate dialog procedure
		mov eax, esp
		add eax, 8
		.if [eax] = DWORD WM_COMMAND
			.if [eax+4] = DWORD MENU_FORMLISTEDITOR_OLD_EDIT
				FORMLISTEDITOR_EDITCOMMAND
			.endif
		.endif
		push [AddrOf_NormalFLSTDlgProc]
		ret
}