;The G.E.C.K. PowerUp for New Vegas - Unit test
;This is a test for printf function
;This is NOT a part of PowerUp, just a function test
;File version 0.2
;Written by Fedor Uvarov, 2010
;Men of Chelyabinsk are so manly that they write unit tests also in assembly

format PE CONSOLE 4.0
entry start

include 'win32a.inc'
include 'macro\if.inc'
include 'library\printf.asm'

section '.data' data readable writeable
hOut dd ?
CharsWritten dd ?
OldESP1 dd ?
OldESP2 dd ?
ErrorString db "ESP error", 0
EndOf_ErrorString:
TestString1 db "This is a test string!", 0Dh, 0Ah, 0
TestString2 db "This is a test string! 50%% discount.", 0Dh, 0Ah, 0
TestString3 db "We test non-existent format specifiers: %5P, %05TY Hi", 0Ah, 0Dh, 0
TestString4 db "We test %%d and %%i: %i, %d, %i, %d", 0Ah, 0Dh, 0
TestString5 db "We test padding: %4d, %05d, %9i, %3d, %07d", 0Ah, 0Dh, 0
TestString6 db "We test hex: %x, %X, %5X, %04X, %x", 0Ah, 0Dh, 0
TestString7 db "We test strings: %s, %s, it's %d%d! %5s, %05s", 0Ah, 0Dh, 0
TestString7a db "Hello", 0
TestString7b db "world", 0
TestString7cd db "zzz", 0
PRINTF_DATA


section '.text' code readable executable
PRINTF_PROCS

proc output_to_console StringAddr, SizeOfString
	invoke WriteConsole, [hOut], [StringAddr], [SizeOfString], CharsWritten, 0
	ret
endp

macro DoTest FormatString, [arg] {
	common
		mov [OldESP1], esp
	reverse
		if ~ arg eq	;FASM macros SUCK!
			push DWORD arg
		end if
	common
		mov [OldESP2], esp
		push FormatString
		stdcall sprintf_instack_align, esp
		push ecx	;Size to clean
		dec eax	;WriteConsole does not need the null at the end
		stdcall output_to_console, edx, eax
		pop ecx
		add esp, ecx
		add esp, 4	;Format string
		.if ~ [OldESP2] = esp
			stdcall output_to_console, ErrorString, EndOf_ErrorString - ErrorString
			invoke ExitProcess, 1
		.endif
	forward
		if ~ arg eq
			add esp, 4	;Format arguments
		end if
	common
		.if ~ [OldESP1] = esp
			stdcall output_to_console, ErrorString, EndOf_ErrorString - ErrorString
			invoke ExitProcess, 1
		.endif
}

start:
invoke GetStdHandle, STD_OUTPUT_HANDLE
mov [hOut], eax
DoTest TestString1
DoTest TestString2
DoTest TestString3, 50, 0
DoTest TestString4, 100, 1232, 0, -100
DoTest TestString5, 1, 0, -2, 10, -50
DoTest TestString6, 0A95Bh, 05555h, 06h, 01Fh, 1
DoTest TestString7, TestString7a, TestString7b, 15, 28, TestString7cd, TestString7cd
invoke ExitProcess, 0


section '.imports' import data readable
library kernel, 'kernel32.dll'
import kernel,\
	GetStdHandle, 'GetStdHandle',\
	WriteConsole, 'WriteConsoleA',\
	ExitProcess, 'ExitProcess'


section '.reloc' fixups data readable